//============================================================================
// Name        : functors.cpp
// Author      : G Lipari
// Version     :
// Copyright   : OOSD
// Description : Hello World in C++, Ansi-style
//============================================================================

#include <iostream>
#include <string>
#include <loki/Functor.h>
#include <loki/TypelistMacros.h>

using namespace std;
using namespace Loki;

class SimpleFun {
public:
	void operator()() {
		cout << "This is SimpleFun::operator()" << endl;
	}
};

int myfun()
{
	cout << "This is myfun()" << endl;
	return 5;
}

int twoparam(int a, double b)
{
	cout << "This is twoparam(), with a = " << a << " and b = " << b << endl;
	return 6;
}

char ss[] = "This is a C-style string";

const char * getString(double g) {
	cout << "g = " << g << endl;
	return ss;
}

int main() {
	cout << "**** A functor   *** " << endl;
	SimpleFun sf;

	Functor<void> fn0(sf);

	fn0();

	cout << "**** No argument *** " << endl;

	Functor<int> fn1(myfun);

	cout << fn1() << endl;

	cout << "**** Two arguments *** " << endl;

	Functor<int, LOKI_TYPELIST_2(int, double)> fn2(twoparam);

	cout << fn2(8, 10) << endl;

	cout << "**** Type conversion *** " << endl;

	Functor<string, LOKI_TYPELIST_1(int)> fn3(getString);

	cout << fn3(6).substr(0, 12) << endl;

	cout << "**** Type conversion *** " << endl;

	Functor<int, LOKI_TYPELIST_1(double)> fn4( BindFirst(fn2, 33) );

	cout << fn4(5.7) << endl;

	return 0;
}
